/*******************************************************************************
 * Copyright 2015 Julian Oppermann, TU Darmstadt
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 ******************************************************************************/

#ifndef CUSTOMPASSES_H_
#define CUSTOMPASSES_H_

#include "llvm/Pass.h"
#include "llvm/ADT/StringRef.h"

using namespace llvm;

namespace cellml {
namespace opt {

Pass *createNoAliasInserterPass();
Pass *createIntrinsicMapperPass();
Pass *createOptimisationPlaygroundPass();
Pass *createEquationSystemBuilderPass();
Pass *createExpressionReuserPass();
Pass *createAreaEstimaterPass();
Pass *createCSynthesiserPass();
Pass *createDotWriterPass();
Pass *createInstanceInfoPass(StringRef ModelName, StringRef OptimisationLevelName);

}
}

#endif /* CUSTOMPASSES_H_ */
