/*
   There are a total of 2 entries in the algebraic variable array.
   There are a total of 3 entries in each of the rate and state variable arrays.
   There are a total of 1 entries in the constant variable array.
 */
/*
 * VOI is time in component environment (millisecond).
 * STATES[0] is foo in component bar (some unit).
 * STATES[1] is foo in component bar (some unit).
 * STATES[2] is foo in component bar (some unit).
 * CONSTANTS[0] is is foo in component bar (some unit).
 * ALGEBRAIC[0] is foo in component bar (some unit).
 * ALGEBRAIC[1] is foo in component bar (some unit).
 * RATES[0] is d/dt V in component membrane (millivolt).
 * RATES[1] is d/dt foo in component bar (dimensionless).
 * RATES[2] is d/dt h foo in component bar  (dimensionless).
 */
void
initConsts(double* CONSTANTS, double* RATES, double *STATES)
{
STATES[0] = 1;
STATES[1] = 0.05;
STATES[2] = 100;
CONSTANTS[0] = 42;
}
void
computeRates(double VOI, double* CONSTANTS, double* RATES, double* STATES, double* ALGEBRAIC)
{
ALGEBRAIC[0] =  - 0.100000*(STATES[0]+50.0000)/(exp(- (STATES[0]+50.0000)/10.0000) - 1.00000);
ALGEBRAIC[1] =  4.00000*exp(- (STATES[0]+75.0000)/18.0000);
RATES[1]     =  ALGEBRAIC[1]*(1.00000 - STATES[1]) -  ALGEBRAIC[0]*STATES[1];
RATES[2]     =  ALGEBRAIC[0]*(1.00000 - STATES[2]) -  ALGEBRAIC[1]*STATES[2];
RATES[0]     = - (- ALGEBRAIC[0]+ALGEBRAIC[1])/CONSTANTS[0];
}
void
computeVariables(double VOI, double* CONSTANTS, double* RATES, double* STATES, double* ALGEBRAIC)
{
  /* ignored by cellml-opt */
}
